/* Server remote_sort */

#include<stdio.h>
#include<string.h>
#include<signal.h>
#include<errno.h>
#include<fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 256

/* gestore per raccogliere lo stato di terminazione del figlio ed evitare che diventi zombie */
void gestore(int signo)
{
 int stato;
 printf("esecuzione gestore di SIGCHLD\n");
 wait(&stato);
}

main(int argc, char *argv[])
{
 int sd, ns, fd, flag=0;
 char buff[DIM_BUFF];
 int fromlen, status, nread, nwrite;

 struct sockaddr_in mio_indirizzo, rem_indirizzo;
 struct hostent *host;
 memset((char *)&mio_indirizzo, 0, sizeof(struct sockaddr_in));
 fromlen=sizeof(struct sockaddr_in);

 sigset(SIGCHLD, gestore);
 sd=socket(AF_INET, SOCK_STREAM, 0); /*socket d'ascolto*/
 if(sd<0) {perror("apertura socket"); exit(1);}
 printf("Server: creata la socket sd=%d\n", sd);


 mio_indirizzo.sin_family=AF_INET;
 mio_indirizzo.sin_port=12347;

 if(bind(sd,(struct sockaddr *) &mio_indirizzo, sizeof(struct sockaddr_in))<0) {
	perror("bind"); exit(1); 
 }
 printf("Server: bind ok, mi metto in ascolto\n");

 listen(sd,5);
 
 for(;;) {
   
	if((ns=accept(sd,(struct sockaddr *)&rem_indirizzo,&fromlen))<0) {
	if (errno==EINTR) {
		perror("Forzo la continuazione della accept");
		continue;
	} else exit(1);
   }


   if (fork()==0) { /* figlio */
	close(sd);
	host=gethostbyaddr( (char *) &rem_indirizzo.sin_addr, sizeof(rem_indirizzo.sin_addr), AF_INET);
        if (host == NULL) {
            printf("host information not found\n"); exit (1);
        }
	printf("Server (figlio): host client e' %s \n", host->h_name); 

	/* controllo di autorizzazione */

	if ((fd=open("autorizzati.txt", O_RDONLY))<0){
		printf("errore nell'apertura del file autorizzati\n");}
	else	
		while((nread=read(fd, buff, DIM_BUFF))>0) { 
			
			if (strstr( buff, host->h_name)!=0) {
				flag=1;
				printf("Server (figlio): Autorizzazione OK\n");
			}
		}
	if(flag==0) {
		write(ns, "N", 1); 
		printf("Autorizzazione negata \n");
		exit(0);
	} 

	if ((nwrite=write(ns, "S", 1))<0) {perror("write"); exit(1);} 
	
	printf("Server (figlio): eseguo l'ordinamento\n");
	close(1); close(0); 
	dup(ns); dup(ns);
	
	execl("/bin/sort", "sort", (char *)0);
 }

 close(ns);
}
}


